// Write API_KEY:  A5FEN34GFTY32ZFI
// Read API_KEY : KHQ5F7TNPW4TI5OI

// GET /update?key=5B9ZEY2QG2H2MG9E&field1=55 \r\n

#include <SoftwareSerial.h>

#define RX 7
#define TX 8

#define MAX_WAIT 7000

String AP = "Lovcen"; // CHANGE ME
String PASS = ""; // CHANGE ME

String API = "VHNXNES2MJ5YML7K";   // CHANGE ME
String HOST = "api.thingspeak.com";
String PORT = "80";
String field1 = "field1";

int countTrueCommand;
int countTimeCommand;
boolean found = false;
int valSensor = 1;
unsigned long start;

SoftwareSerial esp8266(RX, TX);

void setup() {
  Serial.begin(9600);
  esp8266.begin(9600);
  sendCommand("AT", 5, 100, "OK");
  sendCommand("AT+CWMODE=1", 5, 500, "OK");
  sendCommand("AT+CWJAP=\"" + AP + "\",\"" + PASS + "\"", 20, 10000, "OK");
}

void loop() {
  valSensor = getSensorData();
  String getData = "GET /update?api_key=" + API + "&" + field1 + "=" + String(valSensor);
  Serial.println(getData);
  
  sendCommand("AT+CIPMUX=1", 1, 1000, "OK");
  sendCommand("AT+CIPSTART=0,\"TCP\",\"" + HOST + "\"," + PORT, 1, 2000, "OK");
  sendCommand("AT+CIPSEND=0," + String(getData.length() + 4), 1, 3000, ">");
  esp8266.println(getData); delay(1500); countTrueCommand++;
  sendCommand("AT+CIPCLOSE=0", 1, 2000, "OK");
  delay(15000);
}

int getSensorData() {
  return random(1000); // Replace with
}

void sendCommand(String command, int maxTime, int Wait, char readReplay[]) {
  Serial.print(countTrueCommand);
  Serial.print(". at command => ");
  Serial.print(command);
  Serial.print(" ");
  while (countTimeCommand < maxTime)
  {
    start = millis();
    esp8266.println(command);
    while ((millis() - start) < Wait) {
      if (esp8266.find(readReplay)>0) //ok
      {
        found = true;
        break;
      }
    }
    if(found==true)break;
    countTimeCommand++;
  }

  if (found == true)
  {
    Serial.println("OK");
    countTrueCommand++;
    countTimeCommand = 0;
  }

  if (found == false)
  {
    Serial.println("Fail");
    countTrueCommand = 0;
    countTimeCommand = 0;
  }
  found = false;
}
